﻿Imports System.IO.IsolatedStorage
Imports System.IO
Imports System.Text
Imports System.Device.Location

Partial Public Class Add
    Inherits PhoneApplicationPage

    Private location As String = ""

    Public Sub New()
        InitializeComponent()

        Dim myWatcher As New GeoCoordinateWatcher

        Dim myPosition = myWatcher.Position

        ' In this case,since we're not working with a device, I'll just
        ' set a default value.  If we cannot get the current location,
        ' then we'll default to Redmond, WA.
        Dim latitude = 47.674
        Dim longitude = -122.12

        If Not myPosition.Location.IsUnknown Then
            latitude = myPosition.Location.Latitude
            longitude = myPosition.Location.Longitude
        End If

        Dim client As New myTerraService.TerraServiceSoapClient

        AddHandler client.ConvertLonLatPtToNearestPlaceCompleted, AddressOf client_ConvertLonLatPtToNearestPlaceCompleted

        client.ConvertLonLatPtToNearestPlaceAsync(New myTerraService.LonLatPt With {.Lat = latitude, .Lon = longitude})

    End Sub

    Private Sub client_ConvertLonLatPtToNearestPlaceCompleted(ByVal sender As Object, ByVal e As myTerraService.ConvertLonLatPtToNearestPlaceCompletedEventArgs)
        location = e.Result

        'Throw New NotImplementedException
    End Sub

    Private Sub AppBar_Cancel_Click(ByVal sender As Object, ByVal e As EventArgs)
        navigateBack()
    End Sub

    Private Sub AppBar_Save_Click(ByVal sender As Object, ByVal e As EventArgs)
        ' Save the new note
        If location.Trim().Length = 0 Then
            location = "Unknown"
        End If

        ' Construct the name of the file.
        Dim sb As New StringBuilder
        sb.Append(Date.Now.Year)
        sb.Append("_")
        sb.Append(String.Format("{0:00}", Date.Now.Month))
        sb.Append("_")
        sb.Append(String.Format("{0:00}", Date.Now.Day))
        sb.Append("_")
        sb.Append(String.Format("{0:00}", Date.Now.Hour))
        sb.Append("_")
        sb.Append(String.Format("{0:00}", Date.Now.Minute))
        sb.Append("_")
        sb.Append(String.Format("{0:00}", Date.Now.Second))
        sb.Append("_")

        location = location.Replace(" ", "-")
        location = location.Replace(", ", "_")
        sb.Append(location)
        sb.Append(".txt")

        ' Now we have everthing we need ... write the file
        ' to IsolatedStorage.
        Dim appStorage = IsolatedStorageFile.GetUserStoreForApplication()

        Using fileStream = appStorage.OpenFile(sb.ToString(), System.IO.FileMode.Create)
            Using sw As New StreamWriter(fileStream)
                sw.WriteLine(editTextBox.Text)
            End Using
        End Using

        ' Finished.  Navigate back to MainPage.
        navigateBack()
    End Sub

    Private Sub navigateBack()
        NavigationService.Navigate(New Uri("/XapNote;component/MainPage.xaml", UriKind.Relative))
    End Sub

    Private Sub PhoneApplicationPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
        editTextBox.Focus()
    End Sub

End Class

